image:
  name: registry.gitlab.com/gitlab-org/terraform-images/stable:latest

variables:
  TF_ROOT: ${CI_PROJECT_DIR}/terraform  # The relative path to the root directory of the Terraform project
  TF_STATE_NAME: ${CI_COMMIT_BRANCH} # The name of the state file used by the GitLab Managed Terraform state backend

cache:
  key: "${TF_ROOT}"
  paths:
    - ${TF_ROOT}/.terraform/

stages:
  - prepare
  - build
  - deploy
  - destroy

validate:
  stage: prepare
  script:
    - gitlab-terraform init
    - gitlab-terraform validate

plan:
  stage: build
  before_script:
  - cd ${TF_ROOT}
  script:
    - gitlab-terraform plan
    - gitlab-terraform plan-json
  resource_group: ${TF_STATE_NAME}
  artifacts:
    name: plan
    paths:
      - ${TF_ROOT}/plan.cache
    reports:
      terraform: ${TF_ROOT}/plan.json

apply:
  stage: deploy
  before_script:
  - cd ${TF_ROOT}
  script:
    - gitlab-terraform apply
  resource_group: ${TF_STATE_NAME}
  when: manual
  
destroy:
  stage: destroy
  before_script:
  - cd ${TF_ROOT}
  script:
    - gitlab-terraform destroy
  resource_group: ${TF_STATE_NAME}
  dependencies:
    - apply
  when: manual 
